/**
 * Created by tonyjiang on 16/3/14.
 */
import ChoosePhotoPlugin from '../interface'
import {ChanjetDecorator} from 'chanjet-plugin-base'

@ChanjetDecorator
class ChoosePhotoPluginChanjet extends ChoosePhotoPlugin{

    constructor(){
        super();

        if(!mutants){
            return false;
        }

        const {ios , android} = mutants.env.constant.os;

        this.pluginName = {};
        this.pluginName[ios] = 'Album';
        this.pluginName[android] = 'AlbumPlugin';

        this.methodName = {};
        this.methodName[ios] = {
            takePhoto : 'selectImgsNoUpload'
        };
        this.methodName[android] = {
            takePhoto : 'selectImgs'
        };

    }

    _defaultChoosePhotoOption = {
        "quality" : 0 ,
        "maxCount" : 9
    };


    /**
     *
     * @param options
     *      @property options.maxCount 最大选图数量, 默认9张
     *      @property options.quality 0:高质量(默认) , 1:中等质量 , 2:低质量
     * @param callback 执行完成后回调
     * @param requestId 应用自己分配的值,用于在restore时判断数据来源进行后续操作.
     *
     */
    choosePhoto(options , callback , requestId = ''){

        const {os} = mutants.env;

        Object.assign(options , Object.assign({} , this._defaultChoosePhotoOption , options));

        const pluginName = this.pluginName[os];
        const methodName = this.methodName[os].takePhoto;

        cordova.exec(
            this._choosePhotoSuccessHandler.bind(this , callback , requestId),
            this._choosePhotoFailedHandler.bind(this ,callback , requestId),
            pluginName , methodName , [options , requestId]
        )
    }

    _choosePhotoSuccessHandler(callback , requestId , data){

        const {os} = mutants.env;
        const {android , ios} = mutants.env.constant.os;

        //如果是安卓
        if(os == android){
            const result = {
                resultCode : data.result,
                message : data.message,
                requestId : data.requestId,
                body : {
                    data : data.urls
                }
            };
            callback(result);
        }else {//如果是ios
            const rsJSON = JSON.parse(data);

            const resultCode = rsJSON.code == 0 ? 0 : 1;
            const message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);
            
            const result = {
                resultCode : resultCode,
                message : message,
                requestId : requestId,
                body : {
                    data : rsJSON.data.nativeUrls
                }
            }

            callback(result);
        }

    }

    _choosePhotoFailedHandler(callback , requestId , error){
        const rs = {
            resultCode : 1,
            message : error,
            requestId : requestId,
            body : {}
        };
        callback(rs);
    }

}

export default ChoosePhotoPluginChanjet