/**
 * Created by TonyJiang on 16/4/27.
 */
import PluginTestUtil from 'chanjet-plugin-base/dist/PluginTestUtil';
import ChoosePhotoPlugin from '../src/chanjet'

global.mutants = {
    env : {
        os : 'ios',
        constant : {
            os : {
                ios : 'ios',
                android : 'android'
            }
        }
    }
};

const pluginName = {
    ios : 'Album',
    android : 'AlbumPlugin'
};

const methodName = {
    ios : 'selectImgsNoUpload',
    android : 'selectImgs'
};

const instance = new ChoosePhotoPlugin();
const testUtil = new PluginTestUtil();
testUtil.init(cordova);


describe('ChoosePhotoPluginChanjet 单元测试' , () => {

    describe('ios环境下通用测试' , () => {
        mutants.env.os = mutants.env.constant.os.ios;
        //ios环境, 通用测试
        testUtil.commonTest({
            funcName : 'choosePhoto',
            func : instance.choosePhoto.bind(instance),
            pluginName : pluginName[mutants.env.os],
            methodName : methodName[mutants.env.os],
            validateParams : ['quality' , 'maxCount'],
            params : {}
        });
    });


    describe('android环境下通用测试' , () => {
        mutants.env.os = mutants.env.constant.os.android;
        //android环境, 通用测试
        testUtil.commonTest({
            funcName : 'choosePhoto',
            func : instance.choosePhoto.bind(instance),
            pluginName : pluginName[mutants.env.os],
            methodName : methodName[mutants.env.os],
            validateParams : ['quality' , 'maxCount'],
            params : {}
        });
    });

    
});
